#!/bin/bash

export LD_LIBRARY_PATH=/usr/local/lfzm/ffmpeg/lib/:$LD_LIBRARY_PATH
export PATH=/usr/local/lfzm/ffmpeg/bin:$PATH

Install_Ffmpeg()
{

    install_dir=/usr/local/lfzm/ffmpeg

    Echo_Blue "[+] Installing ${Ffmpeg_Ver}... "
    cd ${cur_dir}/src

    Min_Stall "lame-3.99.5" "tar.gz" "--enable-shared"
    Min_Stall "libogg-1.1.3" "tar.gz"
    Min_Stall "libvorbis-1.3.3" "tar.gz" "--enable-shared"

    echo "=============install xvidcore==============="
    tar -zxvf xvidcore-1.3.2.tar.gz
    cd xvidcore-1.3.2/build/generic
    ./configure --prefix=$install_dir
    make && make install
    cd ${cur_dir}/src

    Min_Stall "last_x264" "tar.bz2" "--disable-asm --enable-shared" "x264-snapshot-20141105-2245"
    Min_Stall "libdca-0.0.5" "tar.bz2"
    Min_Stall "a52dec-0.7.4" "tar.gz"
    Min_Stall "faad2-2.7" "tar.gz"

    echo "=============install faac==============="
    tar -zxvf faac-1.28.tar.gz
    cd faac-1.28
    mp4v2="common/mp4v2/mpeg4ip.h"
    line_number=126
    line_all=`cat $mp4v2 | wc -l`
    let line_before=$line_number-1
    let line_after=$line_all-$line_number
    cat $mp4v2 | head -n $line_before > tmp.h
    cat $mp4v2 | tail -n $line_after >> tmp.h
    mv $mp4v2 $mp4v2".bak" -f
    mv tmp.h $mp4v2 -f
    ./configure --prefix=$install_dir
    make && make install
    cd ${cur_dir}/src

    Min_Stall "amrnb-11.0.0.0" "tar.bz2"
    Min_Stall "amrwb-11.0.0.0" "tar.bz2"
    Min_Stall "opencore-amr-0.1.4" "tar.gz"

    cp ffmpeg/lib/* $install_dir/lib/ -f
    cp -r ffmpeg/include/* $install_dir/include/ -f

    Min_Stall "ffmpeg-3.3.2" "tar.bz2" "--enable-libmp3lame \
                                       --enable-libvorbis \
                                       --enable-gpl \
                                       --enable-version3 \
                                       --enable-nonfree \
                                       --enable-pthreads \
                                       --enable-libopencore-amrnb \
                                       --enable-libopencore-amrwb \
                                       --enable-libx264 \
                                       --enable-libxvid \
                                       --enable-postproc \
                                       --enable-ffserver \
                                       --disable-yasm \
                                       --enable-ffplay \
                                       --extra-cflags=\"-I$install_dir/include\" \
                                       --extra-ldflags=\"-L$install_dir/lib\""
    
}
