#!/bin/bash

Install_Nginx()
{
    Echo_Blue "[+] Installing ${Nginx_Ver}... "
    groupadd www
    useradd -s /sbin/nologin -g www www
    cd ${cur_dir}/src
    Tar_Cd ${Nginx_Ver}.tar.gz ${Nginx_Ver}
    if echo ${Nginx_Ver} | grep -Eqi 'nginx-[0-1].[5-8].[0-9]' || echo ${Nginx_Ver} | grep -Eqi 'nginx-1.9.[1-4]$'; then
        ./configure --user=www --group=www --prefix=/usr/local/lfzm/nginx --with-http_stub_status_module --with-http_ssl_module --with-http_spdy_module --with-http_gzip_static_module --with-ipv6 --with-http_sub_module ${Nginx_Modules_Options}
    else
        ./configure --user=www --group=www --prefix=/usr/local/lfzm/nginx --with-http_stub_status_module --with-http_ssl_module --with-http_v2_module --with-http_gzip_static_module --with-ipv6 --with-http_sub_module ${Nginx_Modules_Options}
    fi
    make && make install
    cd ../

    ln -sf /usr/local/lfzm/nginx/sbin/nginx /usr/bin/nginx

    rm -f /usr/local/lfzm/nginx/conf/nginx.conf
    cd ${cur_dir}
    \cp conf/nginx.conf /usr/local/lfzm/nginx/conf/nginx.conf
    \cp conf/pathinfo.conf /usr/local/lfzm/nginx/conf/pathinfo.conf
    \cp conf/thinkphp.conf /usr/local/lfzm/nginx/conf/thinkphp.conf
    \cp conf/enable-php.conf /usr/local/lfzm/nginx/conf/enable-php.conf
    \cp conf/enable-php-pathinfo.conf /usr/local/lfzm/nginx/conf/enable-php-pathinfo.conf
    \cp conf/enable-ssl-example.conf /usr/local/lfzm/nginx/conf/enable-ssl-example.conf
    \cp conf/enable-mp4.conf /usr/local/lfzm/nginx/conf/enable-mp4.conf

    mkdir -p ${Default_Website_Dir}
    chmod +w ${Default_Website_Dir}
    mkdir -p /home/wwwlogs
    chmod 777 /home/wwwlogs

    chown -R www:www ${Default_Website_Dir}

    mkdir /usr/local/lfzm/nginx/conf/vhost

    if [ "${Default_Website_Dir}" != "/home/wwwroot/default" ]; then
        sed -i "s#/home/wwwroot/default#${Default_Website_Dir}#g" /usr/local/lfzm/nginx/conf/nginx.conf
    fi

    cat >${Default_Website_Dir}/.user.ini<<EOF
open_basedir=${Default_Website_Dir}:/tmp/:/proc/
EOF
    chmod 644 ${Default_Website_Dir}/.user.ini
    chattr +i ${Default_Website_Dir}/.user.ini
    cat >>/usr/local/lfzm/nginx/conf/fastcgi.conf<<EOF
fastcgi_param PHP_ADMIN_VALUE "open_basedir=\$document_root/:/tmp/:/proc/";
EOF

    \cp init.d/init.d.nginx /etc/init.d/nginx-lfzm
    chmod +x /etc/init.d/nginx-lfzm
}
