#!/bin/bash
PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:~/bin
export PATH

# Check if user is root
if [ $(id -u) != "0" ]; then
    echo "Error: You must be root to run this script, please use root to install lnmp"
    exit 1
fi

cur_dir=$(pwd)

LFZM_Ver='1.0'
. lfzm.conf
. include/main.sh
. include/init.sh
. include/php.sh
. include/nginx.sh
. include/ffmpeg.sh
. include/end.sh

Get_Dist_Name

if [ "${DISTRO}" = "unknow" ]; then
    Echo_Red "Unable to get Linux distribution name, or do NOT support the current distribution."
    exit 1
fi


Check_LFZMConf

clear
echo "+------------------------------------------------------------------------+"
echo "|          LFZM V${LFZM_Ver} for ${DISTRO} Linux Server, Written by Licess          |"
echo "+------------------------------------------------------------------------+"
echo "|        A tool to auto-compile & install LFZM/LFZMA/LAMP on Linux       |"
echo "+------------------------------------------------------------------------+"
echo "|           For more information please visit http://www.lfdycms.com     |"
echo "+------------------------------------------------------------------------+"

Init_Install()
{
    Press_Install
    Print_APP_Ver
    Get_Dist_Version
    Print_Sys_Info
    Check_Hosts
    Check_Mirror
    if [ "${DISTRO}" = "RHEL" ]; then
        RHEL_Modify_Source
    fi
    if [ "${DISTRO}" = "Ubuntu" ]; then
        Ubuntu_Modify_Source
    fi
    Set_Timezone
    if [ "$PM" = "yum" ]; then
        CentOS_InstallNTP
        CentOS_Dependent
    elif [ "$PM" = "apt" ]; then
        Deb_InstallNTP
        Xen_Hwcap_Setting
        Deb_Dependent
    fi
    Disable_Selinux
    # 下载软件
    Check_Download
    Install_Autoconf
    Install_Libiconv
    Install_Libmcrypt
    Install_Mhash
    Install_Mcrypt
    Install_Freetype
    Install_Pcre
    Install_Icu4c
    Install_Sqlite
    if [ "$PM" = "yum" ]; then
        CentOS_Lib_Opt
    elif [ "$PM" = "apt" ]; then
        Deb_Lib_Opt
    fi
    PHP_with_curl
    PHP_with_openssl
}

LFZM_Stack()
{
    Init_Install
    Install_PHP_56
    LFZM_PHP_Opt
    Install_Nginx
    Install_Ffmpeg
    # 安装php软件
    Creat_PHP_Tools
    Add_Iptables_Rules
    Add_LFZM_Startup
    Check_LFZM_Install
}

Dispaly_Selection
LFZM_Stack 2>&1 | tee /root/lnmp-install.log

exit
